(function flexible(window, document) {
  var docEl = document.documentElement

  // adjust body font size
  function setBodyFontSize() {
    if (document.body) {
      document.body.style.fontSize = '.14rem'
    } else {
      document.addEventListener('DOMContentLoaded', setBodyFontSize)
    }
  }
  setBodyFontSize()

  // set 1rem = viewWidth / 3.75
  function setRemUnit() {
    var rem = (docEl.clientWidth > 750 ? 750 : docEl.clientWidth) / 3.75
    docEl.style.fontSize = rem + 'px'
  }

  setRemUnit()

  // reset rem unit on page resize
  window.addEventListener('resize', setRemUnit)
  window.addEventListener('pageshow', function(e) {
    if (e.persisted) {
      setRemUnit()
    }
  })

})(window, document)
